#ifndef SMEARING_h
#define SMEARING_h
//----------------
#include "Moses.h"
//----------------


using namespace std;

namespace Moses1 {

	class smearing {
	public:
		smearing();
		virtual ~smearing();
		
		virtual void   settings(double average, double sigma, double resolution, double pTTrackScale);		

		virtual double gaussRand();

		virtual double pTsmear(double pT);

		virtual double pT2px(double pTsmeared, double phi);
		virtual double pT2py(double pTsmeared, double phi);
		virtual double pT2pz(double pTsmeared, double theta);
		virtual double pT2e(double pTsmeared,  double theta);

		virtual void   compare2true(double pxOrig, double pyOrig, double pzOrig, double eOrig);
	
	private:
		TRandom *gaussGenerator;
		double m_average, m_sigma, m_resolution, m_pTTrackScale, m_gaussRand;
		double m_pTSmeared, m_pxSmeared, m_pySmeared, m_pzSmeared, m_eSmeared;

};

}
#endif
